package com.book.dao.cps.pojo;

import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * admin_config
 *
 * @author
 */
@Data
public class AdminConfig implements Serializable {
    /**
     * 渠道商ID
     */
    private Integer adminId;

    /**
     * 是否强制授权:0=不强制,1=强制
     */
    private Object isFouce;

    /**
     * 入口域名id
     */
    private Integer entryhostId;

    /**
     * 平台列表
     */
    private String platformList;

    /**
     * 平台id
     */
    private Integer platformId;

    /**
     * 菜单平台ID
     */
    private Integer menuPlatformId;

    /**
     * 业务id
     */
    private Integer ophostId;

    /**
     * 支付id
     */
    private Integer wxpayId;

    /**
     * 每天导粉最大数
     */
    private Integer fansCount;

    /**
     * 微信appId
     */
    private String appid;

    /**
     * 微信APP secret
     */
    private String secret;

    /**
     * 微信txt验证文件
     */
    private String txt;

    /**
     * 微信token刷新令牌
     */
    private String refreshToken;

    /**
     * 微信第三方授权返回json数据
     */
    private Object json;

    /**
     * 微信菜单
     */
    private Object wxMenu;

    /**
     * 是否授权:0=未授权,1=已授权
     */
    private Object isAuth;

    /**
     * 公众号二维码
     */
    private String qrcodeImage;

    /**
     * 默认关注章节数
     */
    private Integer bookGuideChapterIdx;

    /**
     * 章节价格
     */
    private Integer bookChapterPrice;

    /**
     * 关注方式:1=强制关注,2=引导关注,3=不关注
     */
    private Object subscribeMethod;

    /**
     * 引导关注链接
     */
    private String subscribeUrl;

    /**
     * 客服资料
     */
    private String managerContact;

    /**
     * 新用户活动状态:0=关闭,1=开启
     */
    private Object newUserActivity;

    /**
     * 未支付提醒:0=关闭,1=开启
     */
    private Object unpayTip;

    /**
     * 定制书籍提醒:0=关闭,1=开启
     */
    private Object readTip;

    /**
     * 继续阅读提醒:0=关闭,1=开启
     */
    private Object continuereadTip;

    /**
     * 签到图文推送:0=关闭,1=开启
     */
    private Object signTip;

    /**
     * 凌晨模式:0=关闭,1=开启
     */
    private Object morningPattern;

    /**
     * 关注图文推送:0=关闭,1=开启
     */
    private Object subscribeTip;

    /**
     * 追更开关：0=关闭，1=开启
     */
    private Object updateTip;

    /**
     * 自动回复书籍搜索:0=关闭,1=打开
     */
    private Object searchTip;

    /**
     * 定时推送开关:0=关闭,1=开启
     */
    private Object timingTip;

    /**
     * 猜你喜欢提醒:0=关闭,1=开启
     */
    private Object likeTip;

    /**
     * 页面模板:0=男女,1=男,2=女
     */
    private Object pageSex;

    /**
     * 页面标题
     */
    private Object pageTitle;

    /**
     * vip扣单间隔
     */
    private Integer vipNum;

    /**
     * 普通扣单间隔
     */
    private Integer normalNum;

    /**
     * 黑名单
     */
    private Boolean isBlacklist;

    /**
     * vip订单间隔
     */
    private Integer agentVipNum;

    /**
     * 普通订单间隔
     */
    private Integer agentNormalNum;

    /**
     * 是否开启:0=关闭,1=开启
     */
    private Boolean agentIsBlacklist;

    /**
     * 创建时间
     */
    private Integer createtime;

    /**
     * 更新时间
     */
    private Integer updatetime;

    /**
     * 微信菜单业务域名
     */
    private Integer menuophostId;

    /**
     * 微信菜单支付域名
     */
    private Integer menuwxpayId;

    /**
     * 虚假业务域名
     */
    private Integer fakeophostId;

    /**
     * 虚假菜单业务域
     */
    private Integer fakemenuophostId;

    /**
     * KL比例
     */
    private BigDecimal klRate;

    /**
     * 自定义商品顺序:0=关闭,1=开启
     */
    private Byte customGoods;

    /**
     * VIP充值开关:0=关闭,1=开启
     */
    private Boolean vipState;

    /**
     * 微信转化数据源接入:0=关闭,1=开启
     */
    private Boolean wxAdState;

    /**
     * VIP充值商品
     */
    private Integer vipGoodsId;

    /**
     * VIP充值页模板
     */
    private String vipPayTpl;

    /**
     * 推广链接第一章外派:0=关闭,1=开启
     */
    private Boolean refOutPush;

    /**
     * 短链域名&倒粉域名开关
     */
    private Object guideDomain;

    /**
     * 微信AD转化数据源ID
     */
    private Long wxAdSourceId;

    /**
     * 自家转移号(智能客服使用)
     */
    private Object isAccountSelf;

    /**
     * 赠币活动开关
     */
    private Object giveKandian;

    /**
     * 自定义活动展示到充值页面:0=关闭,1=开启
     */
    private Byte activityShowRechargePage;

    /**
     * 关注回复延时消息 1关闭 2开启
     */
    private Object subscribeDelay;

    /**
     * 子商户帐号
     */
    private Object palmpaySubAccountIds;

    /**
     * 首充优惠图文推送开关:0=关闭,1=开启
     */
    private Object firstRechargeImgtextPost;

    /**
     * 首充优惠图文推送规则.默认15分钟
     */
    private Byte orderUnrechargePostTime;

    /**
     * 微信菜单是否是二维码图片:0=不是,1=是
     */
    private Object isQrcodeMenu;

    /**
     * 回调时间:1=关注当日所有充值,2=关注后24小时内所有充值,3=关注当日首充,4=关注后24小时内首充
     */
    private Byte callbackTimeTout;

    /**
     * 回调时间:1=关注当日所有充值,2=关注后24小时内所有充值,3=关注当日首充,4=关注后24小时内首充
     */
    private Byte callbackTimeMp;

    /**
     * 回调时间:1=关注当日所有充值,2=关注后24小时内所有充值,3=关注当日首充,4=关注后24小时内首充
     */
    private Byte callbackTimeGdt;

    private Double vipCustomMoney;

    /**
     * 回调时间:1=关注当日所有充值,2=关注后24小时内所有充值,3=关注当日首充,4=关注后24小时内首充
     */
    private Byte callbackTimeUc;

    /**
     * vip自定义商品
     */
    private Integer vipGoodsIdCustom;

    /**
     * GDT-MP回传:0=关闭,1=开启
     */
    private Byte gdtMpReportState;

    /**
     * 是否开启订阅号
     */
    private Integer isSubscription;

    /**
     * VIP关联渠道商默认数量
     */
    private Integer vipRelationNum;

    /**
     * 订阅号数量
     */
    private Integer subscriptionNum;

    /**
     * 书籍收费起始章节
     */
    private Integer bookChapterChargeStart;

    /**
     * 橙子建站回传开关:0=关,1=开
     */
    private Byte orangeCallback;

    /**
     * vipbanner个人中心展示:0=不展示,1=展示
     */
    private Byte showVipAtHome;

    /**
     * ios用户屏蔽支付开关；0：关闭；1：开启。
     */
    private Byte blockIosUserSwitch;

    /**
     * 扩展字段
     */
    private Object extend;

    /**
     * 是否开启ROI全量上报，0=未开启 1=已开启
     */
    private Byte callbackTimeMpAll;

    /**
     * 自定义回传用户大于Y元的订单
     */
    private Byte callbackTimeMpMoney;

    /**
     * 自定义回传用户X小时内的订单
     */
    private Byte callbackTimeMpHour;

    /**
     * 回调时间:1=关注当日所有充值,2=关注后24小时内所有充值,3=关注当日首充,4=关注后24小时内首充
     */
    private Byte callbackTimeBaidu;

    /**
     * 回调时间:1=关注当日所有充值,2=关注后24小时内所有充值,3=关注当日首充,4=关注后24小时内首充
     */
    private Byte callbackTimeOppo;

    /**
     * 百度回传开关:0=关,1=开
     */
    private Byte baiduCallback;

    /**
     * OPPO回传开关:0=关,1=开
     */
    private Byte oppoCallback;
    private Info info;


    @Data
    public static class Info {
        private AuthorizationInfo authorization_info;
        private AuthorizerInfo authorizer_info;

    }

    @Data
    public static class AuthorizationInfo {

        private String authorizer_appid;
        private String authorizer_refresh_token;
    }

    @Data
    public static class AuthorizerInfo {
        private String alias;
        private int idc;
        private String nick_name;
        private String principal_name;
        private String qrcode_url;
        private String signature;
        private String user_name;

    }

    private static final long serialVersionUID = 1L;
}