package com.book.dao.cps.pojo;

import java.io.Serializable;
import java.math.BigDecimal;
import lombok.Data;

/**
 * orders
 * @author 
 */
@Data
public class Orders implements Serializable {
    private Integer id;

    /**
     * 用户ID
     */
    private Long userId;

    /**
     * 渠道商/代理商ID
     */
    private Integer adminId;

    /**
     * 资源ID
     */
    private Integer resourceId;

    /**
     * 支付号ID
     */
    private Integer wxpayId;

    /**
     * 收益分成比例[2位小数]
     */
    private BigDecimal benefit;

    /**
     * 金额
     */
    private BigDecimal money;

    /**
     * 金额收益
     */
    private BigDecimal moneyBenefit;

    /**
     * 支付方式 category.nickname
     */
    private String category;

    /**
     * 业务线:0=微信,1=APP
     */
    private Integer businessLine;

    /**
     * 订单ID
     */
    private String payid;

    /**
     * 商户内部订单号
     */
    private String outTradeNo;

    /**
     * 微信支付订单号
     */
    private String transactionId;

    /**
     * 下单IP
     */
    private String ip;

    /**
     * 推广ID
     */
    private Integer referralId;

    /**
     * 永久referral_id
     */
    private Integer referralIdPermanent;

    /**
     * 书籍ID
     */
    private Long bookId;

    /**
     * 章节ID
     */
    private Long chapterId;

    /**
     * 商品ID
     */
    private Integer goodsId;

    /**
     * 充值看点数
     */
    private Integer kandian;

    /**
     * 赠送看点数
     */
    private Integer freeKandian;

    /**
     * VIP天数
     */
    private Integer day;

    /**
     * 充值类型:1=看点充值,2=VIP充值
     */
    private Object type;

    /**
     * 订单状态:0=待支付,1=已支付
     */
    private Object state;

    /**
     * 活动ID
     */
    private Integer activityId;

    /**
     * 是否扣单:0=不是扣单,1=是扣单
     */
    private Boolean deduct;

    /**
     * 赏金邀请人
     */
    private Integer rewardAdminId;

    /**
     * 赏金金额
     */
    private BigDecimal rewardMoney;

    /**
     * 赏金比例
     */
    private BigDecimal rewardBenefit;

    /**
     * 创建时间
     */
    private Integer createtime;

    /**
     * 更新时间
     */
    private Integer updatetime;

    /**
     * 完成时间
     */
    private Integer finishtime;

    /**
     * 支付方式:0=微信支付,1=四方支付
     */
    private Boolean paymentMethod;

    /**
     * 四方平台订单号
     */
    private String pdorderid;

    /**
     * 四方支付json
     */
    private String payJson;

    /**
     * push_id,push_idx,mark,push_time...
     */
    private String ext;

    /**
     * 渠道ID
     */
    private Integer channelId;

    /**
     * 渠道分成比例
     */
    private BigDecimal channelBenefit;

    /**
     * 角色组 3=渠道 4=代理
     */
    private Byte group;

    /**
     * ??ID
     */
    private Integer platformId;

    /**
     * 推送标记
     */
    private Integer mark;

    /**
     * ????:0=????,1=????
     */
    private Boolean paymentMethod1;

    /**
     * ???????
     */
    private String pdorderid1;

    /**
     * 渠道分成金额
     */
    private BigDecimal channelBenefitMoney;

    private static final long serialVersionUID = 1L;
}