package com.book.dao.cps.pojo;

import com.fasterxml.jackson.annotation.JsonAlias;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;

import java.io.Serializable;

/**
 * user
 *
 * @author
 */
@Data
public class User implements Serializable {
    private Long id;

    /**
     * 微信openID
     */
    private String openid;

    /**
     * 微信unionid
     */
    @JsonIgnore
    private String unionid;

    /**
     * 访客id
     */
    @JsonIgnore
    private String visitor;

    /**
     * 昵称
     */
    private String nickname;

    /**
     * 状态值:0=未知,1=男性,2=女性
     */
    private Object sex;

    /**
     * 手机号
     */
    @JsonProperty("phone")
    private String mobile;

    /**
     * 头像
     */
    private String avatar;

    /**
     * 关注公众号状态:1=已关注,0=未关注
     */
    @JsonProperty("subscribe")
    private Object isSubscribe;

    /**
     * 关注引导公众号状态:1=已关注,0=未关注
     */
    @JsonIgnore
    private Object subscriptionExtend;

    /**
     * 关注时间
     */
    @JsonIgnore
    private Integer subscribeTime;

    /**
     * 喜好书籍分类
     */
    @JsonIgnore
    private String bookCategoryIds;

    /**
     * 微信交互时间戳
     */
    @JsonIgnore
    private Integer operateTime;

    /**
     * 首充状态:1=已充值,0=未充值
     */
    @JsonIgnore
    private Object isPay;

    /**
     * 充值看点数
     */
    @JsonProperty("coin")
    private Integer kandian;

    /**
     * 赠送看点数
     */
    @JsonProperty("freeCoin")
    private Integer freeKandian;

    /**
     * VIP到期时间
     */
    @JsonIgnore
    private Integer vipEndtime;

    /**
     * 注册IP
     */
    @JsonIgnore
    private String registerIp;

    /**
     * 国家
     */
    @JsonIgnore
    private String country;

    /**
     * 区域
     */
    @JsonIgnore
    private String area;

    /**
     * 省份
     */
    @JsonIgnore
    private String province;

    /**
     * 城市
     */
    @JsonIgnore
    private String city;

    /**
     * isp服务商
     */
    @JsonIgnore
    private String isp;

    /**
     * 关联渠道商ID
     */
    @JsonIgnore
    private Integer channelId;

    /**
     * 状态值:0=禁用,1=正常
     */
    private Object state;

    /**
     * 创建时间
     */
    @JsonIgnore
    private Integer createtime;

    /**
     * 更新时间
     */
    @JsonIgnore
    private Integer updatetime;

    private static final long serialVersionUID = 1L;
}