package com.book.push.builder;

import me.chanjar.weixin.mp.api.WxMpService;
import me.chanjar.weixin.mp.bean.kefu.WxMpKefuMessage;
import me.chanjar.weixin.mp.bean.message.WxMpXmlMessage;
import me.chanjar.weixin.mp.bean.message.WxMpXmlOutImageMessage;
import me.chanjar.weixin.mp.bean.message.WxMpXmlOutMessage;
import me.chanjar.weixin.mp.bean.message.WxMpXmlOutNewsMessage;

import java.util.List;

/**
 * created in 2021/8/28
 * Project: book-store
 *
 * @author win7
 */

public class TuWenBuilder extends AbstractBuilder {


    @Override
    public WxMpXmlOutMessage build(String content, WxMpXmlMessage wxMessage, WxMpService service) {
        WxMpXmlOutNewsMessage m = WxMpXmlOutMessage.NEWS().articles(null)
                .fromUser(wxMessage.getToUser()).toUser(wxMessage.getFromUser())
                .build();

        return m;
    }
    public WxMpXmlOutMessage build(WxMpXmlOutNewsMessage.Item item,  WxMpXmlMessage wxMessage, WxMpService service) {
        WxMpXmlOutNewsMessage build = WxMpXmlOutMessage.NEWS().addArticle(item)
                .fromUser(wxMessage.getToUser()).toUser(wxMessage.getFromUser()).build();


        return build;
    }
    public WxMpXmlOutMessage build(List<WxMpXmlOutNewsMessage.Item> items, WxMpXmlMessage wxMessage, WxMpService service) {
        WxMpXmlOutNewsMessage build = WxMpXmlOutMessage.NEWS().articles(items)
                .fromUser(wxMessage.getToUser()).toUser(wxMessage.getFromUser()).build();


        return build;
    }
}
