package com.book.push.controller;

import com.book.dao.utils.TimeUtil;
import com.book.push.service.wx.WxThirdPartService;
import com.book.push.vo.result.Result;
import lombok.extern.slf4j.Slf4j;
import me.chanjar.weixin.mp.bean.kefu.WxMpKefuMessage;
import me.chanjar.weixin.mp.builder.kefu.TextBuilder;
import me.chanjar.weixin.open.api.WxOpenMpService;
import me.chanjar.weixin.open.api.WxOpenService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * created in 2021/9/28
 * Project: book-store
 * http://mp.esalary.com.cn/kefu/send?appid=wxe1271417b2ff5b1c&openid=ou1lt1YlMHsrUSm1FJ98PCd31yFI
 * @author win7
 */
@Slf4j
@RestController
@RequestMapping("/kefu")
public class KefuTestController {
    @Autowired
    private WxThirdPartService wxThirdPartService;

    @GetMapping("/send")
    public Result hello(@RequestParam String appid, @RequestParam String openid, @RequestParam(required = false) String msg) {
        log.info("测试发送：", appid, openid);
        if (StringUtils.isEmpty(msg)) {
            msg = "测试发送客服消息:" + TimeUtil.getCurrentDate(TimeUtil.YYYY_M_DD_HH_MM_SS);
        }
        try {
            WxMpKefuMessage build = new TextBuilder().toUser(openid).content(msg).build();
            WxOpenService wxOpenService = wxThirdPartService.getWxOpenServiceByPlatFormId(7);
            WxOpenMpService wxMpService = wxOpenService.getWxOpenComponentService().getWxMpServiceByAppid(appid);
            wxMpService.getKefuService().sendKefuMessage(build);
        } catch (Exception e) {
            return Result.failure(99, e.getMessage());
        }


        return Result.success();


    }

}
