package com.book.push.handler;

import com.book.dao.cps.pojo.User;
import com.book.push.service.dao.AdminConfigService;
import com.book.push.service.dao.UserService;
import lombok.extern.slf4j.Slf4j;
import me.chanjar.weixin.common.session.WxSessionManager;
import me.chanjar.weixin.mp.api.WxMpService;
import me.chanjar.weixin.mp.bean.message.WxMpXmlMessage;
import me.chanjar.weixin.mp.bean.message.WxMpXmlOutMessage;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Map;

/**
 * @author
 */
@Slf4j
@Component
public class UnsubscribeHandler extends AbstractHandler {
    @Autowired
    private UserService userService;
    @Override
    public WxMpXmlOutMessage handle(WxMpXmlMessage wxMessage,
                                    Map<String, Object> context, WxMpService wxMpService,
                                    WxSessionManager sessionManager) {
        String openId = wxMessage.getFromUser();
       log.info("取消关注用户 OPENID: " + openId);
        // TODO 可以更新本地数据库为取消关注状态
        User user = userService.selectByOpenId(openId);
        User updateUser = new User();
        updateUser.setId(user.getId());
        updateUser.setIsSubscribe("0");
        updateUser.setIsSubscribe("0");

        userService.updateUserSelective(updateUser);
        return null;
    }

}
