package com.book.push.service.dao.impl;

import com.book.dao.cps.mapper.PlatformMapper;
import com.book.dao.cps.pojo.Platform;
import com.book.push.service.dao.PlatformService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * created in 2021/8/19
 * Project: book-store
 *
 * @author win7
 */
@Service
public class PlatformServiceImpl implements PlatformService {
    @Autowired
    private PlatformMapper platformMapper;

    @Override
    public Map<Integer, Platform> selectAll() {
        List<Platform> platforms = platformMapper.selectAll();
        Map<Integer, Platform> collect = platforms.stream().collect(Collectors.toMap(Platform::getId, Platform -> Platform));
        return collect;
    }

    @Override
    public Platform selectByAppid(String appId) {
        return platformMapper.selectByAppid(appId);
    }
}
