package com.book.push.service.dao.impl;

import com.book.dao.cpsshard.entity.UserRecentlyRead;
import com.book.dao.cpsshard.mapper.UserRecentlyReadMapper;
import com.book.dao.cpsshard.pojo.example.UserRecentlyReadExample;
import com.book.push.service.dao.UserRecentReadService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * created in 2021/9/1
 * Project: book-store
 *
 * @author win7
 */
@Service
public class UserRecentReadServiceImpl implements UserRecentReadService {
    @Autowired
    private UserRecentlyReadMapper userRecentlyReadMapper;

    @Override
    public UserRecentlyRead selectLastByUserId(long userId) {
        UserRecentlyReadExample example = UserRecentlyReadExample.newAndCreateCriteria()
                .andUserIdEqualTo(userId).example().orderBy(UserRecentlyRead.Column.updatetime.desc()).limit(1);
        return userRecentlyReadMapper.selectOneByExample(example);
    }

    @Override
    public List<UserRecentlyRead> selectLastGroupByUserId(Integer from,Integer to) {

        return userRecentlyReadMapper.selectLastGroupByUserId(from, to);
    }

    @Override
    public UserRecentlyRead selectUserRecentlyReadById(Integer id) {
        return userRecentlyReadMapper.selectByPrimaryKey(id);
    }
}
