package com.book.push.service.redis;

import com.book.push.config.KeyExpiredListener;

import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * created in 2021/8/20
 * Project: book-store
 * www.cnblogs.com/liuling/p/2014-4-19-04.html
 * @author win7
 */

public interface RedisService {

    void set(String key, String value);

    String get(String key);
    Long getExpiresTime(String key);

    void setMap(String key,Map<String, String> map);
    List<String> getByMapKey(String key, String mapKey);
    void setList(String key,String... val);
    void setList(String key,List<String> list);
    List<String> getList(String key,int begin,int end);

    void setSet(String key, Set<String> set);

    Set<String> getSet(String key);

    void set(String key, String value, long second);


    Long del(String key);

    KeyExpiredListener getKeyListener();
}
