package com.book.push.service.redis.impl;

import com.book.push.config.KeyExpiredListener;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.core.annotation.Order;
import org.springframework.stereotype.Component;
import redis.clients.jedis.Jedis;
import redis.clients.jedis.JedisPool;

/**
 * created in 2021/9/7
 * Project: book-store
 *
 * @author win7
 */
@Component
@Order(1)
public class Subscriber implements CommandLineRunner {
    private String redisTopic = "__keyevent@0__:expired";


    @Autowired
    private JedisPool jedisPool;
    @Autowired
    private KeyExpiredListener keyExpiredListener;

    @Override
    public void run(String... args) throws Exception {
        System.out.println("============================开启redis监听=============================================");
        Jedis jedis = jedisPool.getResource();
        jedis.psubscribe(keyExpiredListener, redisTopic);

    }
}
