package com.book.push.task;

import com.book.dao.cps.pojo.AdminConfig;
import com.book.dao.cps.pojo.User;
import com.book.dao.cpsshard.entity.Sign;
import com.book.dao.cpsshard.entity.UserRecentlyRead;
import com.book.dao.utils.DateUtils;
import com.book.push.service.dao.*;
import com.book.push.service.push.PushService;
import com.book.push.service.wx.WxThirdPartService;
import me.chanjar.weixin.mp.bean.kefu.WxMpKefuMessage;
import me.chanjar.weixin.mp.builder.kefu.TextBuilder;
import me.chanjar.weixin.open.api.WxOpenMpService;
import me.chanjar.weixin.open.api.WxOpenService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * created in 2021/9/1
 * Project: book-store
 *
 * @author win7
 */
@Component
public class NoSignTask {
    @Autowired
    private AdminConfigService adminConfigService;
    @Autowired
    private WxThirdPartService wxThirdPartService;
    @Autowired
    private UserService userService;
    @Autowired
    private SignService signService;

    @Autowired
    private UserRecentReadService userRecentReadService;
    @Autowired
    private PushService pushService;
    @Autowired
    private BookService bookService;

//    @Scheduled(fixedRate = 1000 * 60 * 30)
    public void run() {
        Integer from = DateUtils.getNow() - 24 * 60 * 60;
        Integer to = from + (30 * 60);
        List<Sign> list = signService.selectAllUserLastSign(from,to);
        for(Sign sign:list){
            Integer uid = sign.getUid();
            User user = userService.selectById(uid.longValue());
            Integer channelId = user.getChannelId();
            AdminConfig adminConfig = adminConfigService.selectByAdminId(channelId);
           /* if (adminConfig.getSignTip().equals("0")){
                continue;
            }*/
            String openid = user.getOpenid();
            String appid = adminConfig.getAppid();
            Integer platformId = adminConfig.getPlatformId();
            WxOpenService wxOpenService = wxThirdPartService.getWxOpenServiceByPlatFormId(platformId);
            WxOpenMpService wxMpService = wxOpenService.getWxOpenComponentService().getWxMpServiceByAppid(appid);
            String msg = String.format("亲，您今天还没有签到哦，点击%n签到即可领取书币哟~%n%n<a href='weixin://bizmsgmenu?msgmenucontent=签到&msgmenuid=0'>点我签到</a>%n%n为了方便下次阅读，请置顶公众号");
            WxMpKefuMessage wxMpKefuMessage = new TextBuilder().toUser(user.getOpenid()).content(msg).build();
            pushService.addWxKefuMessagePushTask(wxMpService, wxMpKefuMessage, to - (sign.getCreatetime()));

        }
    }
}
