package com.book.push.utils;

import java.util.ArrayList;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.util.ArrayList;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
/**
 * created in 2021/9/6
 * Project: book-store
 *
 * @author win7
 */

public class UrlUtil {




        /**
         * 获取网络的根域名
         * @param url
         * @return
         */
        public static String getDomainName(String url){
            String pattern = "/(?!/)";
            Pattern compile = Pattern.compile(pattern);
            Matcher matcher = compile.matcher(url);
            ArrayList<Integer> list = new ArrayList<>();
            while (matcher.find()){
                list.add(matcher.start());
            }
            return url.substring(0, list.get(1)).split("//")[1];
        }

        /**
         *根据 index 来返回几级域名<br/>
         * 如果 index为0，则返回顶级域名，如http://localhost:8080/。<br/>
         * 如果index大于url所包含的最大域名级数就返回url<br/>
         * @param url
         * @param index  域名的级别，0为顶级域名，以此类推。
         * @return
         */
        public static String getDomainName(String url,int index){
            String pattern = "/(?!/)";
            Pattern compile = Pattern.compile(pattern);
            Matcher matcher = compile.matcher(url);
            ArrayList<Integer> list = new ArrayList<>();
            while (matcher.find()){
                list.add(matcher.start());
            }

            try{
                //如果index大于url所包含的最大域名级数就返回url
                //这里面list的size减一就是这个url的最大级数，因为list包含一个/是url中http://的/。所以不应该算数
                if(index>=list.size()-1){
                    return url;
                }else if (index<0){
                    return null;
                }else {
                    return url.substring(0, list.get(index+1)+1);
                }
            }catch (Exception e){
                e.printStackTrace();
                return null;
            }
        }

        public static String replaceDomain  (String url,String domain){
          return   url.replace(getDomainName(url),domain);
        }

        public static String addParams(String url,String params){
            String s = url.contains("?")?"&":"?";
            return url.concat(s).concat(params);
        }

    public static void main(String[] args) {
        System.out.println(getDomainName("http://localhost:8080/test/session"));
    }
}
