package com.book.server.common.util;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;

import static com.book.server.config.Const.CacheSplit;

public class CacheUtil {
    /**
     * 所有前缀
     */
    public static String PRE = "SER__";

    public static String getKeyWithPre(String pre, Object[] keys) {
        StringBuilder sb = new StringBuilder(PRE);
        sb.append(pre).append(CacheSplit);
        sb.append(getKey(keys));
        return sb.toString();
    }

    public static String getKey(Object... keys) {
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < keys.length; i++) {
            sb.append(keys[i]);
            if (i < keys.length - 1) {
                sb.append(CacheSplit);
            }
        }
        return sb.toString();
    }

    public static void main(String[] args) {
        ArrayList<String> strings = new ArrayList<>();
        strings.add("1");
        strings.add("1");
        System.out.println(getKeyWithPre("test", strings.toArray()));
    }
}
