package com.book.server.controller;

import com.book.dao.cps.entity.Goods;
import com.book.server.common.entity.Result;
import com.book.server.service.GoodsService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * 商品
 */
@RestController
@RequestMapping("/api/goods")
@Slf4j
public class GoodsController extends BaseController{
    @Autowired
    private GoodsService goodsService;

    /**
     * 获取固定支付种类
     * @return
     */
    @GetMapping("/get")
    public Result<List<Goods>> getUnPayedGoods() {
        List<Goods> unPayedGoods = goodsService.getUnPayedGoods();
        return Result.success(unPayedGoods);
    }
}
