package com.book.server.controller;

import com.book.dao.VO.LoginVO;
import com.book.dao.cps.entity.Login;
import com.book.server.common.entity.Result;
import com.book.server.service.LoginService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.Cookie;
import javax.servlet.http.HttpSession;

/**
 * 登录
 */
@RestController
@Slf4j
@RequestMapping("/api/login")
public class LoginController extends BaseController {

    @Autowired
    private LoginService loginService;

    /**
     * 登录
     * @param loginVO
     * @param session
     * @return
     */
    @PostMapping("/login-28A0C169-E1A6-4AFE-B3A5-96AC046DFFB9")
    public Result login(@RequestBody Login loginVO, HttpSession session) {
        boolean login = loginService.login(loginVO);
        if (login) {
            session.setAttribute("login", true);
            return Result.success();
        } else {
            return Result.failure();
        }
    }

    /**
     * 添加
     * @param login
     * @return
     */
    @PostMapping("/add-EAF80D36-6334-4366-A5A1-854B41446F40")
    public Result add(@RequestBody Login login) {
        return Result.byObject(loginService.add(login));
    }

    /**
     * 更新
     * @param login
     * @return
     */
    @PostMapping("/update-EAF80D36-6334-4366-A5A1-854B41446F40")
    public Result update(@RequestBody Login login) {
        return Result.byObject(loginService.update(login));
    }
}
