package com.book.server.service;

import com.book.dao.VO.*;
import com.book.dao.cps.pojo.Book;
import com.book.dao.cps.pojo.SearchKeyword;
import com.book.dao.cpsshard.entity.UserRecentlyRead;
import com.book.server.common.entity.Result;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.List;
import java.util.concurrent.ExecutionException;

public interface BookService {
    List<BookRes> query(QueryVO queryVO);
    List<BookRes> recommendByRead(QueryVO queryVO);

    List<BlockRes> getBlockByPageId(Integer pageId) throws ExecutionException;

    void insertBooks();

    List<Chapter> getChaptersByBookId(Long bookId);

    List<SearchKeyword> getSearchKeywordBySex(String sex);

    List<BookRes> topRecommend(QueryVO queryVO);

    List<BookRes> smartRecommand(QueryVO queryVO);

    Result<BookContent> getContentByContentId(BookContentVO bookContentVO);

    UserRecentlyRead getRecentReadByUserIdAndBookId(UserRecentlyRead userRecentlyRead);

    List<UserRecentlyReadRes> getRecentReadByUserId(UserRecentReadVO userRecentlyRead);

    List<Long> getUserConsumerChapter(BookContentVO bookContentVO);

    void addFile(MultipartFile file, Long id) throws IOException;

    Result<BookContent> getContentByContentId2(BookContentVO bookContentVO);

    Boolean updateBookContent(BookContentVO bookContentVO);
    int insertKandian(Long userId, String type, int kandian, int freeKandian);

    Long getRecommendId();

    int deleteUploadFile(Long id);
}
