package com.book.server.service;

import com.book.dao.VO.SunVO;
import com.book.dao.polardb.entity.SunChannel;
import com.book.dao.polardb.entity.SunOrder;
import com.book.dao.polardb.entity.SunOrderCollect;
import com.book.dao.polardb.entity.SunUserCollect;
import com.book.server.common.entity.PageResult;
import com.book.server.common.entity.Result;
import com.book.server.config.SunTypeEnum;
import com.book.server.vo.SunNotifyRequest;
import com.book.server.vo.SunRequest;

/**
 * created in 2021/9/28
 * Project: book-store
 *
 * @author win7
 */

public interface SunDataService {

    Result requestData(SunRequest request,SunTypeEnum sunTypeEnum);

    void pullData(SunNotifyRequest request);

    PageResult<SunChannel> pageSunChannel(SunVO sunVO);

    PageResult<SunOrder> pageSunOrder(SunVO sunVO);

    PageResult<SunOrderCollect> pageOrderCollect(SunVO sunVO);

    PageResult<SunUserCollect> pageUserCollect(SunVO sunVO);

}
