package com.book.server.service.impl;

import com.book.dao.cps.entity.Goods;
import com.book.dao.cps.mapper.GoodsMapper;
import com.book.dao.cps.pojo.example.GoodsExample;
import com.book.server.annotation.CacheFind;
import com.book.server.service.GoodsService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class GoodServiceImpl implements GoodsService {
    @Autowired
    private GoodsMapper goodsMapper;

    @Override
    @CacheFind(key = "unPayedGoods")
    public List<Goods> getUnPayedGoods() {
        GoodsExample example = GoodsExample.newAndCreateCriteria()
                .andShowTypeEqualTo("0")
                .example();
        example.orderBy(Goods.Column.weigh.asc());
        return goodsMapper.selectByExample(example);
    }
}
