package com.book.server.service.impl;

import com.book.dao.VO.LoginVO;
import com.book.dao.cps.entity.Login;
import com.book.dao.cps.mapper.LoginMapper;
import com.book.dao.cps.mapper.UserMapper;
import com.book.dao.cps.pojo.example.LoginExample;
import com.book.server.service.LoginService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class LoginServiceImpl implements LoginService {
    @Autowired
    private LoginMapper loginMapper;

    @Override
    public boolean login(Login loginVO) {
        Login login = loginMapper.selectOneByExample(LoginExample.newAndCreateCriteria()
                .andUserNameEqualTo(loginVO.getUserName())
                .andPasswordEqualTo(loginVO.getPassword())
                .example()
        );
        return login != null;
    }

    @Override
    public boolean add(Login loginVO) {
        int insert = loginMapper.insert(loginVO);
        return insert > 0;
    }

    @Override
    public Boolean update(Login login) {
        int i = loginMapper.updateByExampleSelective(login, LoginExample.newAndCreateCriteria()
                .andUserNameEqualTo(login.getUserName())
                .example(), Login.Column.password);
        return i > 0;
    }
}
