package com.book.server.service.impl;

import com.book.dao.cps.entity.OrdersCollect;
import com.book.dao.cps.mapper.OrdersCollectMapper;
import com.book.dao.cps.mapper.OrdersMapper;
import com.book.dao.cps.pojo.Orders;
import com.book.dao.cps.pojo.example.OrdersCollectExample;
import com.book.dao.utils.DateUtils;
import com.book.dao.utils.TimeUtil;
import com.book.server.service.BookService;
import junit.framework.TestCase;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.math.BigDecimal;

@SpringBootTest
@RunWith(SpringRunner.class)
public class BookServiceImplTest {

    @Autowired
    private BookServiceImpl bookService;
    @Autowired
    private OrdersMapper ordersMapper;
    @Autowired
    private OrdersCollectMapper ordersCollectMapper;
    @Test
    public void testGetDefaultFreeChapterNum() {
        int defaultFreeChapterNum = bookService.getDefaultFreeChapterNum();
        System.out.println(defaultFreeChapterNum);
    }
    @Test
    public void testUpdateOrderState() {
        Orders orders = new Orders();
        orders.setId(5800);
        orders.setOutTradeNo("1632278760978000107");
        orders.setState("1");
        orders.setPdorderid("2312312");
        orders.setTransactionId("chorderid1");
        orders.setUpdatetime(DateUtils.getNow());
        orders.setFinishtime(DateUtils.getNow());
       ordersMapper.updateByPrimaryKeySelective(orders);
    }
    @Test
    public void testUpdateOrderCollect() {
        OrdersCollect ordersCollect = new OrdersCollect();
        ordersCollect.setAdminId(247);
        ordersCollect.setType("1");
        ordersCollect.setFlag("1");
        ordersCollect.setCreatedate(TimeUtil.getCurrentDate(TimeUtil.YYYYMMDD1));
        ordersCollect.setRechargeMoney(new BigDecimal(1));
        ordersCollect.setRechargeMoneyBenefit(new BigDecimal(1));
        ordersCollect.setNormalRechargeOrdersCount(1);
        ordersCollect.setNormalRechargeUserCount(1);
        ordersCollect.setKandianRechargeOrdersCount(1);
        ordersCollect.setCreatetime(DateUtils.getNow());
        ordersCollect.setRechargeUserCount(1);
        ordersCollect.setKandianRechargeOrders(0);
        OrdersCollectExample ordersCollectExample = OrdersCollectExample.newAndCreateCriteria().andAdminIdEqualTo(ordersCollect.getAdminId())
                .andTypeEqualTo(ordersCollect.getType()).andFlagEqualTo(ordersCollect.getFlag()).andCreatedateEqualTo(ordersCollect.getCreatedate())
                .example();

        OrdersCollect selectOrdersCollect = ordersCollectMapper.selectOneByExample(ordersCollectExample);
        if (selectOrdersCollect==null){
            ordersCollectMapper.insert(ordersCollect);
        }else {
            ordersCollectMapper.updateCollect(ordersCollect);
        }

    }
}